您的位置:时时app平台注册网站 > web前端 > NodeJs之数据库异常处理彩世界网址

NodeJs之数据库异常处理彩世界网址

2019-11-28 05:24

数据库sql语句错误

咱们修正一下代码,将数据库链接填对,改正sql语句为错误的言语。

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            connection.query(queryString, function(err, rows, fields) {
                //if (err) throw err;
                if (!err) {
                    resolve(rows);
                 } else {
                    reject(err)
                 }
                connection.release();
            });
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestairs")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error('[err]',err)
            })
    })
}

报错消息:

[2017-01-05 14:40:14.518] [ERROR] runlog - [err] { [Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement']
  code: 'ER_BAD_FIELD_ERROR',
  errno: 1054,
  sqlState: '42S22',
  index: 0 }
Error: ER_BAD_FIELD_ERROR: Unknown column 'onestairs' in 'group statement'
    at Query.Sequence._packetToError (E:zzzz_wb123managetrunkcodenod
....

能够看来错误都以由此catch抛出。

故此借使接纳了Promise咱俩得以一直在catch中抓到下边抛出的可怜。不要求再去queryPromise函数中打日志格外了。

此地有豆蔻梢头篇stackoverflow管理错误的十三分有效的问答node-js-best-practice-exception-handling

数据库链接错误

运用nodejs管理特别最麻烦然则,这里小编吐弃nodejs提供的domain和有些第三方库特地管理的东西。操作数据库是大家常用的功用。通过回调,大家那边会有无尽err出没。

如下:

var pool = require('../db.js');
var runtimeLog = require('../log.js').getLogger('runlog');
var Promise = require('bluebird');

function queryPromise(queryString) {
    return new Promise(function(resolve, reject) {
        pool.getConnection(function(err, connection) {

            //connection.query(queryString, function(err, rows, fields) {

            //  if (!err) {
            //      resolve(rows);
            //   } else {
            //      runtimeLog.error(err)
            //      reject(err)
            //   }
            //  connection.release();
            //});
        })
    })
}

module.exports = function() {
    return new Promise(function(resolve, reject) {

        queryPromise("select * from wb123_home_map GROUP BY onestair")
            .then(function(results){
                resolve(results);

            })
            .catch(function(err){
                runtimeLog.error(err)
            })
    })
}

能够看来2个回调的地点都会有疏失的恐怕。

而且那是七个模块,大家将它导出了。

此处大家有意识将数据库链接的端口号填错,写成330666:

module.exports = {
    host:     '192.168.6.101',
    database: 'web123',
    user:     'root',
    password: 'passw0rd',
    protocol: 'mysql',
    port:     '330666',
    query:    {pool: true}
}

那样的话,在大家链接数据库的时候是会出错的。

这里我们利用了promise,所以在导出的函数中,大家接收了catch,他会抓到queryPromise函数中的错误,并打字与印刷到日志中。

[2017-01-05 13:27:59.648] [ERROR] runlog - [err] [RangeError: port should be >= 0 and < 65536: 330666]
RangeError: port should be >= 0 and < 65536: 330666
...

数据库极度


NodeJs版本:4.4.4

本文由时时app平台注册网站发布于web前端,转载请注明出处:NodeJs之数据库异常处理彩世界网址

关键词: